-- Load Libraries
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

-- Spell Power Stats
local Arcane_SP_Frame = ldb:NewDataObject("SN - Arcane Dmg", {type = "data source", label = "Arcane Dmg", text = "", icon = "Interface\\Icons\\Spell_Arcane_Blast"})
local Arcane_Crit_Frame = ldb:NewDataObject("SN - Arcane Crit", {type = "data source", label = "Arcane Crit", text = "", icon = "Interface\\Icons\\spell_nature_purge"})
local Nature_SP_Frame = ldb:NewDataObject("SN - Nature Dmg", {type = "data source", label = "Nature Dmg", text = "", icon = "Interface\\Icons\\spell_nature_lightning"})
local Nature_Crit_Frame = ldb:NewDataObject("SN - Nature Crit", {type = "data source", label = "Nature Crit", text = "", icon = "Interface\\Icons\\Spell_Nature_LightningOverload"})
local Fire_SP_Frame = ldb:NewDataObject("SN - Fire Dmg", {type = "data source", label = "Fire Dmg", text = "", icon = "Interface\\Icons\\spell_fire_flamebolt"})
local Fire_Crit_Frame = ldb:NewDataObject("SN - Fire Crit", {type = "data source", label = "Fire Crit", text = "", icon = "Interface\\Icons\\spell_fire_sealoffire"})
local Frost_SP_Frame = ldb:NewDataObject("SN - Frost Dmg", {type = "data source", label = "Frost Dmg", text = "", icon = "Interface\\Icons\\spell_frost_frostbolt02"})
local Frost_Crit_Frame = ldb:NewDataObject("SN - Frost Crit", {type = "data source", label = "Frost Crit", text = "", icon = "Interface\\Icons\\spell_frost_frostshock"})
local Holy_SP_Frame = ldb:NewDataObject("SN - Holy Dmg", {type = "data source", label = "Holy Dmg", text = "", icon = "Interface\\Icons\\Spell_Holy_FlashHeal"})
local Holy_Crit_Frame = ldb:NewDataObject("SN - Holy Crit", {type = "data source", label = "Holy Crit", text = "", icon = "Interface\\Icons\\spell_holy_holynova"})
local Shadow_SP_Frame = ldb:NewDataObject("SN - Shadow Dmg", {type = "data source", label = "Shadow Dmg", text = "", icon = "Interface\\Icons\\spell_shadow_shadowbolt"})
local Shadow_Crit_Frame = ldb:NewDataObject("SN - Shadow Crit", {type = "data source", label = "Shadow Crit", text = "", icon = "Interface\\Icons\\spell_shadow_antishadow"})
local Spell_Hit_Frame = ldb:NewDataObject("SN - Spell Hit", {type = "data source", label = "Spell Hit", text = "", icon = "Interface\\Icons\\Spell_ChargePositive"})
local Healing_Frame = ldb:NewDataObject("SN - Healing", {type = "data source", label = "Healing", text = "", icon = "Interface\\Icons\\spell_holy_greaterheal"})
local Spell_Haste_Frame = ldb:NewDataObject("SN - Spell Haste", {type = "data source", label = "Spell Haste", text = "", icon = "Interface\\Icons\\spell_nature_astralrecalgroup"})
local MP5_Frame = ldb:NewDataObject("SN - MP5", {type = "data source", label = "MP5", text = "", icon = "Interface\\Icons\\Spell_Magic_ManaGain"})

-- Spell Power Frames
local Arcane_DMG = CreateFrame("frame")
local Arcane_CRIT = CreateFrame("frame")
local Nature_DMG = CreateFrame("frame")
local Nature_CRIT = CreateFrame("frame")
local Fire_DMG = CreateFrame("frame")
local Fire_CRIT = CreateFrame("frame")
local Frost_DMG = CreateFrame("frame")
local Frost_CRIT = CreateFrame("frame")
local Holy_DMG = CreateFrame("frame")
local Holy_CRIT = CreateFrame("frame")
local Shadow_DMG = CreateFrame("frame")
local Shadow_CRIT = CreateFrame("frame")
local Spell_Hit = CreateFrame("frame")
local Healing = CreateFrame("frame")
local Spell_Haste = CreateFrame("frame")
local MP5 = CreateFrame("frame")

-- Data Input
Arcane_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Arcane = GetSpellBonusDamage("7")
	Arcane_SP_Frame.text = SP_Arcane
end)

Arcane_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Arcane_Crit = GetSpellCritChance("7")
	Arcane_Crit_Frame.text = string.format("%.2f%%", SP_Arcane_Crit)
end)

Nature_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Nature = GetSpellBonusDamage("4")
	Nature_SP_Frame.text = SP_Nature
end)

Nature_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Nature_Crit = GetSpellCritChance("4")
	Nature_Crit_Frame.text = string.format("%.2f%%", SP_Nature_Crit)
end)

Spell_Haste:SetScript("OnUpdate", function(self, elap)
	local Total_Spell_Haste = GetCombatRatingBonus("20")
	Spell_Haste_Frame.text = string.format("%.2f%%", Total_Spell_Haste)
end)

Fire_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Fire = GetSpellBonusDamage("3")
	Fire_SP_Frame.text = SP_Fire
end)

Fire_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Fire_Crit = GetSpellCritChance("3")
	Fire_Crit_Frame.text = string.format("%.2f%%", SP_Fire_Crit)
end)

Frost_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Frost = GetSpellBonusDamage("5")
	Frost_SP_Frame.text = SP_Frost
end)

Frost_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Frost_Crit = GetSpellCritChance("5")
	Frost_Crit_Frame.text = string.format("%.2f%%", SP_Frost_Crit)
end)

Holy_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Holy = GetSpellBonusDamage("2")
	Holy_SP_Frame.text = SP_Holy
end)

Holy_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Holy_Crit = GetSpellCritChance("2")
	Holy_Crit_Frame.text = string.format("%.2f%%", SP_Holy_Crit)
end)

Shadow_DMG:SetScript("OnUpdate", function(self, elap)
	local SP_Shadow = GetSpellBonusDamage("6")
	Shadow_SP_Frame.text = SP_Shadow
end)

Shadow_CRIT:SetScript("OnUpdate", function(self, elap)
	local SP_Shadow_Crit = GetSpellCritChance("6")
	Shadow_Crit_Frame.text = string.format("%.2f%%", SP_Shadow_Crit)
end)

Spell_Hit:SetScript("OnUpdate", function(self, elap)
	local Total_Spell_Hit = GetCombatRatingBonus("8")
	Spell_Hit_Frame.text = string.format("%.2f%%", Total_Spell_Hit)
end)

Healing:SetScript("OnUpdate", function(self, elap)
	local Total_Healing = GetSpellBonusHealing("player")
	Healing_Frame.text = Total_Healing
end)

MP5:SetScript("OnUpdate", function(self, elap)
	local base, casting = GetManaRegen()
	local MP5_1 = (casting * 5)
	MP5_Frame.text = string.format("%.0f", MP5_1)
end)